package wm.api.demo;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;


import android.app.ListActivity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.os.Environment;
import android.util.Log;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.ListView;

public class MainActivity extends ListActivity {

	private Context mContext = null;

	private static final String MODULE_FLAG_PATH 	= Environment.getDataDirectory()+"/app/config";
	
	private static final String SETTINGS_RFID 		= "RFID API Demo";
	private static final String SETTINGS_UHF_RFID	= "UHF_RFID_API_Demo";
	private static final String SETTINGS_GENERAL 	= "General API Demo";
	private static final int SETTINGS_RFID_ID 		= 0;
	private static final int SETTINGS_GENERAL_ID 	= 1;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		mContext = this;
		InitListView();
	}

	private void InitListView() {
		String[] settingTitleStrings = null;
		Log.e("Demo", "readModuleFlag = " + readModuleFlag());
		if (readModuleFlag().contains("Everay"))
			settingTitleStrings  = new String[] { SETTINGS_UHF_RFID, SETTINGS_GENERAL };
		else 
			settingTitleStrings = new String[] { SETTINGS_RFID, SETTINGS_GENERAL };
		
		setListAdapter(new ArrayAdapter<String>(mContext, android.R.layout.simple_list_item_1, settingTitleStrings));
	}

	@Override
	protected void onListItemClick(ListView list, View view, int position, long id) {
		Intent intent = new Intent();
		switch (position) {
		case SETTINGS_RFID_ID:
			if (readModuleFlag().contains("Everay"))
				intent.setClass(mContext, SettingsUHFRFID.class);
			else 
				intent.setClass(mContext, SettingsRFID.class);
			startActivity(intent);
			break;
		case SETTINGS_GENERAL_ID:
			intent.setClass(mContext, SettingsGeneral.class);
			startActivity(intent);
			break;
		default:
			break;
		}
		super.onListItemClick(list, view, position, id);
	}
	
	private static String readModuleFlag(){
		String moduleFlag=""; 
		try { 
			if(!FileExist( new String(MODULE_FLAG_PATH))) return moduleFlag;
	        
			File file = new File(MODULE_FLAG_PATH);
			FileInputStream fIn = new FileInputStream(file); 
	        InputStreamReader isr = new InputStreamReader(fIn);
	        char[] inputBuffer = new char[56];
	        int len =isr.read(inputBuffer);
	        if(len == -1 ){
	        	isr.close();
	        	return moduleFlag;
	        }
	        
	         moduleFlag = new String(inputBuffer,0,len);
	        isr.close();
	    } catch (IOException ioe) 
	      {ioe.printStackTrace();}
		return moduleFlag;
	}
	
	public static boolean FileExist(String file) {
		File f = new File(file);
		return f.exists();
	}

}
