package wm.api.demo;

import wm.api.general._WM_GENERAL;
import wm.api.rfid._WM_RFID;
import wm.rfid.api.demo.R;
import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;

public class SettingsRFID extends Activity {
	
	
	private _WM_RFID rfid = null;
	
	private Context mContext = null;

	private Button mBtnClean, mBtnReadUID, mBtnReadBlock, mBtnSetABKey, mBtnSelectABKey, mBtnTriggerMode;
	private EditText mSetABKeyData, mResult;
	private Spinner mSpinReadBlock, mSpinSetABKey, mSpinSelectABKey, mSpinTriggerMode, mSpinTriggerTime;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.settings_rfid);
		setTitle("RFID API Demo");
		mContext = this;

		Initialize();
	}
	
	private void Initialize() {
		
		rfid = new _WM_RFID();
		
		InitView();
		InitSpinReadBlock();
		InitSpinSetABKey();
		InitSpinSelectABKey();
		InitSpinTriggerMode();
		InitSpinTriggerTime();
	}
	
	private void InitView() {
		
		mBtnClean		= (Button) findViewById(R.id.button_clean);
		mBtnReadUID	 	= (Button) findViewById(R.id.button_uid);
		mBtnReadBlock 	= (Button) findViewById(R.id.button_read_block);
		mBtnSetABKey 	= (Button) findViewById(R.id.button_set_ab_key);
		mBtnSelectABKey = (Button) findViewById(R.id.button_select_ab_key);
		mBtnTriggerMode = (Button) findViewById(R.id.button_trigger_mode);
		
		mResult 		= (EditText) findViewById(R.id.edit_result);
		mSetABKeyData 	= (EditText) findViewById(R.id.edit_set_ab_key);
		
		mSpinReadBlock 	= (Spinner) findViewById(R.id.spin_read_block);
		mSpinSetABKey 	= (Spinner) findViewById(R.id.spin_set_ab_key);
		mSpinSelectABKey= (Spinner) findViewById(R.id.spin_select_ab_key);
		mSpinTriggerMode= (Spinner) findViewById(R.id.spin_trigger_mode);
		mSpinTriggerTime= (Spinner) findViewById(R.id.spin_trigger_time);
		
		mBtnClean.setOnClickListener(Click_Clean);
		mBtnReadUID.setOnClickListener(Click_Read_UID);
		mBtnReadBlock.setOnClickListener(Click_Read_Block);
		mBtnSetABKey.setOnClickListener(Click_Set_ABKey);
		mBtnSelectABKey.setOnClickListener(Click_Select_ABKey);
		mBtnTriggerMode.setOnClickListener(Click_Trigger_Mode);
	}

	private OnClickListener Click_Clean = new OnClickListener() {
		public void onClick(View v) {
			mResult.setText("");
		}
	};
	private OnClickListener Click_Read_UID = new OnClickListener() {
		public void onClick(View v) {
			read_uid();
		}
	};
	private OnClickListener Click_Read_Block = new OnClickListener() {
		public void onClick(View v) {
			read_block_iso14443();
		}
	};
	private OnClickListener Click_Set_ABKey = new OnClickListener() {
		public void onClick(View v) {
			set_ab_key();
		}
	};
	private OnClickListener Click_Select_ABKey = new OnClickListener() {
		public void onClick(View v) {
			select_ab_key();
		}
	};
	private OnClickListener Click_Trigger_Mode = new OnClickListener() {
		public void onClick(View v) {
			set_trigger_mode();
		}
	};
	
	private void InitSpinReadBlock() {	
		CharSequence[] seq = new CharSequence[0x3F + 1];
		for (int i = 0; i < seq.length; i++) {
			seq[i] = "Block - " + String.valueOf(i);
		}
		ArrayAdapter<CharSequence> adapter = new ArrayAdapter<CharSequence>(this, android.R.layout.simple_spinner_item, seq);
		adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		mSpinReadBlock.setAdapter(adapter);
		mSpinReadBlock.setSelection(0);
	}
	private void InitSpinSetABKey() {	
		CharSequence[] seq = new CharSequence[0x3F + 1];
		for (int i = 0; i < seq.length; i++) {
			if (i < 16)
				seq[i] = "Set A key - " + String.valueOf(i + 1);
			else
				seq[i] = "Set B key - " + String.valueOf(i - 15);
		}
		ArrayAdapter<CharSequence> adapter = new ArrayAdapter<CharSequence>(this, android.R.layout.simple_spinner_item, seq);
		adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		mSpinSetABKey.setAdapter(adapter);
		mSpinSetABKey.setSelection(0);
	}
	private void InitSpinSelectABKey() {
		CharSequence[] seq = new CharSequence[0x3F + 1];
		for (int i = 0; i < seq.length; i++) {
			if (i < 16)
				seq[i] = "A key - " + String.valueOf(i + 1);
			else
				seq[i] = "B key - " + String.valueOf(i - 15);
		}
		ArrayAdapter<CharSequence> adapter = new ArrayAdapter<CharSequence>(this, android.R.layout.simple_spinner_item, seq);
		adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		mSpinSelectABKey.setAdapter(adapter);
		mSpinSelectABKey.setSelection(0);
	}
	
	private void InitSpinTriggerMode() {	
		ArrayAdapter<_WM_RFID.TriggerMode> adapter = new ArrayAdapter<_WM_RFID.TriggerMode>(this, android.R.layout.simple_spinner_item, _WM_RFID.TriggerMode.values());
		adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		mSpinTriggerMode.setAdapter(adapter);
		mSpinTriggerMode.setSelection(0);
	}
	private void InitSpinTriggerTime() {	
		ArrayAdapter<_WM_RFID.TriggerTime> adapter = new ArrayAdapter<_WM_RFID.TriggerTime>(this, android.R.layout.simple_spinner_item, _WM_RFID.TriggerTime.values());
		adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		mSpinTriggerTime.setAdapter(adapter);
		mSpinTriggerTime.setSelection(0);
	}
	//---------------------------------------------------------------------------------------------------------------------------
	
	/****************************************************************************************
	 * 	Read UID
	 *
	 ****************************************************************************************/
	private void read_uid() {
		rfid.ReadUID(mContext);
	}
	
	/****************************************************************************************
	 * Read block data ISO14443 
	 * 
	 * Select one blockPage(0 - 63) to read.
	 * BlockPage = 0, This block saves card ID.   
	 * BlockPage = 3, 7, 11, 15, 19, ..., 63, Those blocks save AB Key.
	 * Another blocks save user data. ex: 1, 2, 4, 5, 6, 8, ... 
	 * 
	 ****************************************************************************************/
	private void read_block_iso14443() {
		int BlockPage = mSpinReadBlock.getSelectedItemPosition();
		Log.i("_WM_", "select block page = " + BlockPage);
		rfid.ReadBlock_ISO14443(mContext, BlockPage); //read block 10
	}
	
	
	/****************************************************************************************
	 * Read block data ISO15693
	 * 
	 * 		ISO15693_Type = TI HF-I Plus, the range of block = 0 - 63
	 * 		ISO15693_Type = TI HF-I Pro, the range of block = 0 - 11
	 * 		ISO15693_Type = I-CODE2, the range of block = 0 V 27
	 * 
	 ****************************************************************************************/
	private void read_block_iso15693() {
		int BlockPage = 10;					//read block 10
		rfid.ReadBlock_ISO15693(mContext, _WM_RFID.ISO15693Type.TI_HF_I_Plus, BlockPage); //read ISO15693 - TI_HF_I_PLUS , block 10
	}
	
	
	/****************************************************************************************
	 * Write block data ISO14443 
	 * 
	 * Select one blockPage(1 - 63) to write.
	 * blockPage 0 is card ID block
	 * 
	 * WriteData is 32 bytes and compose by "0, 1, 2, 3, 4, 5, 6, 7, 8, 9, A, B"  
	 ****************************************************************************************/
	private void write_block_iso14443() {
		int BlockPage = 1;										//write block 1
		String WriteData = "0123456789ABCDEF0123456789ABCDEF"; 	//write block data, 32 bytes
		rfid.WriteBlock_ISO14443(mContext, BlockPage, WriteData);
	}
	
	/****************************************************************************************
	 * Write block data ISO15693
	 * 
	 * 		ISO15693_Type = TI HF-I Plus, the range of block = 0 - 63
	 * 		ISO15693_Type = TI HF-I Pro, the range of block = 0 - 11
	 * 		ISO15693_Type = I-CODE2, the range of block = 0 V 27
	 * 
	 * WriteData is 16 bytes and compose by "0, 1, 2, 3, 4, 5, 6, 7, 8, 9, A, B"
	 ****************************************************************************************/
	private void write_block_iso15693() {
		int BlockPage = 10;	 					//write block 10
		String WriteData = "0123456789ABCDEF"; 	//write block data, 16 bytes
		rfid.WriteBlock_ISO15693(mContext, _WM_RFID.ISO15693Type.TI_HF_I_Plus, BlockPage, WriteData);
	}

	/****************************************************************************************
	 * Set A/B Key
	 * 
	 * ABKey Address = 0 - 31
	 * ABKey Address(0 - 15) is A Key, "0 = A Key1", "1 = A Key2", ..., "15 = A Key16" 
	 * ABKey Address(16 - 31) is B Key, "16 = B Key1", "17 = B Key2", ..., "31 = B Key16" 
	 * 
	 * ABkeyWriteData is 12 bytes and compose by "0, 1, 2, 3, 4, 5, 6, 7, 8, 9, A, B"
	 ****************************************************************************************/
	private void set_ab_key() {
		int keyAddress = mSpinSetABKey.getSelectedItemPosition(); //set A/B Key address
		String keyData = mSetABKeyData.getText().toString(); //write A/B Key value, 12 bytes
		Log.i("_WM_", "set ab key - addr = " + keyAddress + " , " + "data = " + keyData);
		rfid.SetABKey(mContext, keyAddress, keyData);
	}
	
	
	/****************************************************************************************
	 * Select A/B Key
	 * 
	 * ABKey Address = 0 - 31
	 * ABKey Address(0 - 15) is A Key, "0 = A Key1", "1 = A Key2", ..., "15 = A Key16"
	 * ABKey Address(16 - 31) is B Key, "16 = B Key1", "17 = B Key2", ..., "31 = B Key16"
	 **************************************************************************************/
	private void select_ab_key() { 
		int keyAddress = mSpinSelectABKey.getSelectedItemPosition(); //select A/B Key address
		Log.i("_WM_", "select ab key - addr = " + keyAddress);
		rfid.SelectABKey(mContext, keyAddress); //select A/B Key address 1
	}
	

	/****************************************************************************************
	 * 	_WM_RFID API:
	 * 
	 * 	public static enum TriggerMode {
	 *		Auto,
	 *		Single; 
	 *	}
	 *
	 * 	Trigger Mode:
	 * 		1. _WM_RFID.TriggerMode.Auto
	 * 		2. _WM_RFID.TriggerMode.Single
	 * 
	 * **************************************************************************************
	 * _WM_RFID API:
	 * 
	 * 	public static enum TriggerTime {
	 *		Sec_1,
	 *		Sec_2,
	 *		Sec_3,
	 *		Sec_4,
	 *		Sec_5,
	 *		Sec_6,
	 *		Sec_7,
	 *		Sec_8,
	 *		Sec_9;
	 *	}
	 *
	 * 	Trigger Time:
	 * 	 	1. _WM_RFID.TriggerTime.Sec_1 
	 *  		...
	 *  		...
	 *   	9. _WM_RFID.TriggerTime.Sec_9 
	 * 
	 *  Note: If trigger mode is selected "Auto", the trigger time will be ignore.
	 *  
	 **************************************************************************************/
	private void set_trigger_mode() { 
		int mode = mSpinTriggerMode.getSelectedItemPosition(); //select trigger mode
		int time = mSpinTriggerTime.getSelectedItemPosition(); //select trigger time
		Log.i("_WM_", "set_trigger_mode - mode = " + mode + " , " + "time = " + time);
		rfid.SetTriggerMode(mContext, _WM_RFID.TriggerMode.values()[mode], _WM_RFID.TriggerTime.values()[time]);
	}
	
	
}
